"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var execa_1 = tslib_1.__importDefault(require("execa"));
// import * as assert from 'assert';
// import { cpus } from 'os';
var utils_1 = require("../../shared/utils");
function workspacesBuildBinCommand(prog) {
    var _this = this;
    prog
        .command('workspaces build')
        .describe('Build each workspace')
        .example('workspaces build')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('wb')
        .option('i, include', 'Include spe')
        .option('s, self', 'Apply build for the host workspace')
        .example('workspaces build --self')
        .action(function (_a) {
        var self = _a.self;
        return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var stdio, packagesInfo, packagesLocationMap, packageJsons, _b, chunks, unprocessed, chunks_1, chunks_1_1, chunk, chunk_1, chunk_1_1, name, e_1_1, e_2_1, rootDir;
            var e_2, _c, e_1, _d;
            return tslib_1.__generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        stdio = [process.stdin, process.stdout, process.stderr];
                        return [4 /*yield*/, utils_1.getWorkspacesInfo()];
                    case 1:
                        packagesInfo = _e.sent();
                        packagesLocationMap = Object.fromEntries(packagesInfo.map(function (_a) {
                            var name = _a.name, location = _a.location;
                            return [name, location];
                        }));
                        return [4 /*yield*/, utils_1.readWorkspacePackages(packagesInfo)];
                    case 2:
                        packageJsons = _e.sent();
                        _b = utils_1.makeDependencyChunks(packageJsons), chunks = _b.chunks, unprocessed = _b.unprocessed;
                        _e.label = 3;
                    case 3:
                        _e.trys.push([3, 14, 15, 16]);
                        chunks_1 = tslib_1.__values(chunks), chunks_1_1 = chunks_1.next();
                        _e.label = 4;
                    case 4:
                        if (!!chunks_1_1.done) return [3 /*break*/, 13];
                        chunk = chunks_1_1.value;
                        _e.label = 5;
                    case 5:
                        _e.trys.push([5, 10, 11, 12]);
                        chunk_1 = (e_1 = void 0, tslib_1.__values(chunk)), chunk_1_1 = chunk_1.next();
                        _e.label = 6;
                    case 6:
                        if (!!chunk_1_1.done) return [3 /*break*/, 9];
                        name = chunk_1_1.value;
                        console.log("\nEntering " + name + "\n");
                        return [4 /*yield*/, execa_1.default('yarn', ['build'], {
                                cwd: packagesLocationMap[name],
                                stdio: stdio
                            })];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8:
                        chunk_1_1 = chunk_1.next();
                        return [3 /*break*/, 6];
                    case 9: return [3 /*break*/, 12];
                    case 10:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 12];
                    case 11:
                        try {
                            if (chunk_1_1 && !chunk_1_1.done && (_d = chunk_1.return)) _d.call(chunk_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 12:
                        chunks_1_1 = chunks_1.next();
                        return [3 /*break*/, 4];
                    case 13: return [3 /*break*/, 16];
                    case 14:
                        e_2_1 = _e.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 16];
                    case 15:
                        try {
                            if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 16:
                        if (unprocessed.length > 0) {
                            console.log(utils_1.error("Potentially circular dependency\n      Please check the following packages attentively:\n      " + unprocessed.map(function (_a) {
                                var _b = tslib_1.__read(_a, 2), name = _b[0], dependencies = _b[1];
                                var _c;
                                return "   " + name + "  =>  " + ((_c = dependencies === null || dependencies === void 0 ? void 0 : dependencies.join(', ')) !== null && _c !== void 0 ? _c : '');
                            }).join("\n      ") + "\n      "));
                        }
                        if (!self) return [3 /*break*/, 19];
                        console.log("\nEntering host\n");
                        return [4 /*yield*/, utils_1.findWorkspaceRootDir()];
                    case 17:
                        rootDir = _e.sent();
                        return [4 /*yield*/, execa_1.default('yarn', ['build'], { stdio: stdio, cwd: rootDir })];
                    case 18:
                        _e.sent();
                        _e.label = 19;
                    case 19: return [2 /*return*/];
                }
            });
        });
    });
}
exports.workspacesBuildBinCommand = workspacesBuildBinCommand;
